//Terr's Havoc Script Pak version 0.97
//By Darien "Terr" Hager  

//Requires Prestopack
//Hudmover from NewOpts recommended


//Read the README.txt file before continuing.







//I take no responsibitlity for if this script messes up your key bindings. It
//is your responsibility for making sure the script is given the right information.
//I strongly suggest you make a backup of config.cs before running this script.

// There are a few main sections of this pack.

// * Announcements for TONS of Havoc-events.
//  - Power-core-packing items
//  - HAPC deployment
//  - Detpack Announce (sets off teammate's hud timers!!! Woohoo.)
//  - Turret Reprogramming
//  - Explosive disarming.
//  - Enemy Telefrags as an indication of a TP
// * Hud-Timers
//  - Plastiques
//  - Detpacks
//  - Turret Takeovers
//  - Cyborg Shields
//  - Flag Return
//  - Infiltrator Cloaking Grenade
// * Tiptoe script (single keypress does it.)
// * Nearly-on-the-fly video display toggle key, takes only a second or two.
// * Anti-base-rape feature, tosses certain items to deny them to the enemy HOs.
// * Auto-use antidote when poisoned (after a certain time)
// * Auto-use Infiltrator cloak
// * Restore weapon after being emped
// * Links cyberetic laser to sniper rifle, so you shoot at the same time.
// * "Fire on My target" When using the targeting laser.
// * Inbuilt auto-fire-lag for practice sessions on your own server.


// There is really no reason to disable most of these, the only scripts that you
// should probably hesitate at running are the fire-linkage features and most
// of the misc options, because they involve keybinds. Everything else is pretty
// harmless. There are no known compatibility issues, except anything involving
// key-binds, and the fact that the fire-control section might mess with other
// scripts designed to do the same thing.

// EVERYTHING IS DISABLED BY DEFAULT! EACH SECTION HAS A MASTER-SWITCH AT THE
// TOP, WHICH IF SET TO FALSE PREVENTS THE WHOLE SECTION FROM RUNNING.





////////////////////////////////////////////////////////////////////////////////
// Event Announcements                                                        //
////////////////////////////////////////////////////////////////////////////////
$TerrPakPref::MasterAnnounce = False;
// This is the master switch for this Announcement section. False disables.

// SEE TERRMSG.CS TO CHANGE TEXT STRINGS. --------

$TerrPakPref::AnnounceHAPC = True;
// Announces a message when you deploy an HAPC as engineer.

$TerrPakPref::AnnounceDisarm = True;
// Announces when you disarm a plastique or detpack.

$TerrPakPref::AnnouncePowering = True;
// Announces when you are powering a station or a teleport with a power core
// pack.

$TerrPakPref::AnnounceWWire = True;
// Just to let people know you blew up in a worthy cause, if you fail to disarm 
// a detpack/plastique and it blows you up.

$TerrPakpref::AnnounceTurrReprogram = True;
// This tells your team that you have STARTED to reprogram an enemy turret, and
// lets them know how long it will be inactive, even if you fail at the
// reprogramming (by dying, for instance).

$TerrPakpref::AnnounceTurrReprogramSuccess = True;
// Tells your team automatically when you have reprogrammed a turret, to keep
// them from needlessly firing on it, thinking it is still an enemy object.

$TerrPakpref::AnnounceTurrReprogramFail = True;
// This lets your team know that you failed reprogramming the turret, whether
// that is because you died too soon, or the turret was destroyed.

$TerrPakPref::AnnounceTelefrag = True;
// Makes sure your team notices when an enemy is telefragged, since it is a
// rather reliable indication that they either have their own tp or are using
// yours.

$TerrPakPref::AnnounceOOBFlag = True;
// So other teammates don't try to bother getting an OOB flag, and to warn them
// to prepare for a return-grab.

$TerrPakPref::ThispackRules = True;
// Announce that you have this pack. I COULD have not given you an option...
// do whatever the heck you want with this option ;P

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////








////////////////////////////////////////////////////////////////////////////////
// Event-timer script (Grentimer)                                             //
////////////////////////////////////////////////////////////////////////////////
$TerrPakPref::GrenTimerEnabled = False;
// This enables the event-timer script, the original prize and jewel of this
// pack. The script will show count-down timers for up to six events at once:
// One detpack countdown, four plastiques, and a last one for either turret-
// -reprogramming or for the time left on Cyborg beacon shields. (It does one
// or the other in the final timer, since you probably won't be doing both at
// once. There will be a little 'T' for turret timer or a little 'S' for
// shielding to let you know.

// The script will announce to your team when you drop a detpack, and if they
// have the script, their detpack-timer will start. (In newer havoc versions,
// a team may have only one detpack active at a time, so this works out fine.)
// this is useful if TD is on, since your teammates know a big explosion is
// going off, and when.

$TerrPakPref::GrenHudLeft = "100%";
$TerrPakPref::GrenHudTop = "50%";

// Positioning for the hud. I recommend tweaking it with HudMover.



$TerrPakPref::TurretReprogramTimer = True;

// This is for if you want to have a small hud showing how much time until a
// turret is reprogrammed. I recommend this for anyone who tries to capture
// turrets a lot. 

$TerrPakPref::CyborgBeaconTimer = True;

// This lets you know if you have a cyborg beacon (emergency shields) going, and
// how long you have before it runs out. Sometimes the shield will fall early, 
// if you are hit with a railgun, for instance, in which case the timer will
// drop to zero. But for the rest of the time, you know how much of your (about)
// 16 seconds of shielding you have left. I originally intended to add an auto-
// -use feature for the beacons, but decided to leave most of the control in the
// user's hands. That, and it was somehow causing crashes.

$TerrPakPref::CloakTimer = True;

// Timer for infiltrator cloaking grenade. The timer will show a "C" for
// "Cloak". Remember, The shields are S, and Turret takeover is T. This timer
// is seperate from the Turret/Shield one, since it is possible for it to be
// counting when you are taking over a turret.

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////







////////////////////////////////////////////////////////////////////////////////
// Automatic events section                                                   //
////////////////////////////////////////////////////////////////////////////////
$TerrPakPref::MasterAutoUse = False; 
// This is the master-switch for this section.

$TerrPakPref::AutoUseAntidote = True; 
$TerrPakPref::AutoAntidoteDelay = 3.0; 
// This uses an antidote special if you are poisoned, automatically.
// The second option is the time to wait before using the antidote. You want
// to get out of the poison cloud first, otherwise you will just be poisoned
// again. That's why it doesn't do it immediately.

$TerrPakPref::RestoreWpnOnEmp = True; 
$TerrPakPref::WpnCheckTime = 1; 
// This will automatically bring the last weapon you had in your hand back after
// you are emped by a turret or emp mine and drop your gun. Very handy. The
// second option is the time between checks of what gun you have. The script has
// to keep track of what you are holding before the emp hits you, and it does
// that with a recurring timer event that stores the current weapon.

$TerrPakPref::UseDecoyOnFlagTaken = True;
// If you have a flag decoy and someone on your team grabs the flag, you
// automatically use the decoy. If a whole team uses this feature, it could be
// quite annoying for the enemy. "I got the flag carrier! Oops."

$TerrPakPref::FlagDecoyDrop = True;
// If you grab the enemy flag, and happen to have the Flag Decoy special, then
// the script will drop the special. Who knows, it might distract the people
// chasing you and they might go after the decoy.

$TerrPakPref::CloakAutoUse = True;
$TerrPakPref::CloakToggleKey = "i"; // ALT+KEY combo.

// Uses an infiltrator cloaking grenade automatically when the curren one runs
// out. I figure this is actually useful, since you'll probably be using them
// all in one stretch, rather than sporadically, as it is with the cyborg
// beacons. You hit the toggle key (ALT key combo!) to toggle auto-usage on and
// off. This is seperate from the timer-option for cloaking grenades, they work
// independent of each other.

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////






////////////////////////////////////////////////////////////////////////////////
// Play-modifications                                                         //
////////////////////////////////////////////////////////////////////////////////
$TerrPakPref::FireLinkage = False;  
$TerrPakPref::FireDevice = "Mouse0";
$TerrPakPref::FireKey = "button0";
// This feature is NOT compatible with other scripts. Basically, if you set the
// above device and key to what you use for the 'fire' button, then the script
// will be able to use the following options by intercepting the fire-command
// under certain circumstances.

$TerrPakPref::LaserLink = True;
$TerrPakPref::LaserLinkDelay = 0.1;
$TerrPakPref::LaserLinkToggle = "l";
// This needs FireLinkage. If you have a cybernetic laser pack, and are holding
// a sniper rifle, then the script will fire the laser pack when you shoot with
// the rifle, so that both shots hit the target at about the same time for extra
// damage. The Delay option is how long to wait before firing the laser pack.
// This is because the laser is MUCH faster than the bullet, so if you want them
// to HIT at about the same time, you have to stagger their firing times.
//
// The toggle key is a control key combo.



$TerrPakPref::Reptoggle = True;
// This enables click-to-start, click-to-stop features. It works with the repair
// pack, the Engineer repair gun, and the power-core pack. Although some other
// scripts support the repair pack, I don't think any others support the havoc
// engineer repair gun and the powercore pack.
$TerrPakPref::RepToggleKey = "r";
// This key turns the rep-toggle on and off, please note that this is a CONTROL
// key combo, control-r by default. The feature defaults to on, from the
// previous option.

$TerrPakPRef::TargetingAnnounce = True;
// Lets your team know when you fire a targeting laser.

//------------------------------------------------------------------------------
$TerrPakPref::FireLag = False;
$TerrPakPref::MillisecondLag = 100;
// This waits for a few milliseconds before firing your weapon. Why is this use-
// -ful, you ask? Well, only when you are hosting a game and want to practice at
// some larger ping than you get on your own system. It only affects the fire
// function, however, nothing else. This needs firelinkage to work.
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////













////////////////////////////////////////////////////////////////////////////////
// Misc options                                                               //
////////////////////////////////////////////////////////////////////////////////
$TerrPakPref::MiscOptions = False;
// Master switch for this section.


$TerrPakPref::SlowWalkEnabled = True; 
$TerrPakPref::SlowWalkKey = "f"; 
// This binds a single key on your keyboard to tiptoeing. You can normally do
// this by pressing both forward and backward at the same time, to move slowly
// and slip past motion-sensing devices, like motion sensors and indoor turrets.
// The beauty of being able to do it with ONE key is that, at least for me,
// my keyboard locks and makes beeps if I pres more than two keys at once, so
// this lets you change weapons and 1st<->3rd person viewing while tiptoeing.

$TerrPakPref::DispChangerEnabled = True;
$TerrPakPref::DispToggleKey = "F12";
// This option binds a key that toggles between two different sets of video
// settings. This is especially useful if you need to use software mode (lots of
// sneaky enemies in cloaking packs) or if you want to change res or gamma on
// the fly, without going to the options screen.

$TerrPakPref::ModeName1 = "OpenGl, High gamma. 800x600";
$TerrPakPref::Vid1Opt1 = "$pref::VideoFullScreenDriver = \"OpenGL\";";
$TerrPakPref::Vid1Opt2 = "$pref::VideoFullScreenRes = \"800x600\";";
$TerrPakPref::Vid1Opt3 = "$pref::VideoGamma = \"0.999994\";";
// These are example settings for mode one...
// You can add video-related $pref:: variables from clientprefs.cs.. but there
// is a limit of three variables.

$TerrPakPref::ModeName2 = "Software, Medium Gamma. 800x600";
$TerrPakPref::Vid2Opt1 = "$pref::VideoFullScreenDriver = \"Software\";";
$TerrPakPref::Vid2Opt2 = "$pref::VideoFullScreenRes = \"800x600\";";
$TerrPakPref::Vid2Opt3 = "$pref::VideoGamma = \"0.500000\";";
// These are example settings for mode two...
// You can add video-related $pref:: variables from clientprefs.cs.. but there
// is a limit of three variables.


$TerrPakPref::AntiBaseRape = True;
$TerrPakPref::ABRKey = "q"; //ALT KEY COMBO
// I've often wished for this script, so I made it. Basically, this lets you
// bind a key to drop merc beacons/repkits/grens. Why would you do that, you
// ask? Well, if your base is being trashed by an enemy cyborg, and he
// kills you... he gets your beacons. And he can use THOSE as emergency-shields.
// And heal himself with your repkits, and use grenades as mortars...
//
// You get the idea. The ABRkey, "q" by default, is a alt+key combo, so you
// hit alt q to drop stuff. Hit it once to drop all your beacons, and again
// to drop your grenades (useful when your base is populated by an enemy
// behemoth, who can use them as REALLY powerful armageddon missles. A final
// keystroke will drop your health kit. Now, there is a side feature to this...

// By pressing Alt-q rapidly while backing up into an ammo station, you can
// basically spam beacons, grens, and health kits out. This is useful if you are
// trying to rep and don't have a repair pack, and the object to repair is near
// the ammo station, because you can spam out a bunch of repair kits and use a
// bunch of those on it in a row to fix it. Also, you can help supply a few
// teammates in, for instance, behemoth armor. (They can shoot the grens as
// armageddon missles, repair themselves (from the recoil damage) and then use
// the beacons as short-range guided pheonix missles.

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////


















//==============================================================================
$Terrpak::Debug = False;
Include("presto\\Event.cs");
Include("presto\\Events.cs");
Include("presto\\Say.cs");
Include("presto\\HUD.cs");
Include("presto\\TeamTrak.cs");




newObject("Terrpak", SimVolume, "terr\\terrpak.vol");





exec("terr\\terrfunc.cs");

if($TerrPakPref::MasterAnnounce)
{
	exec("terr\\terrann.cs");
	exec("terr\\terrmsg.cs");
}
if($TerrPakPref::GrenTimerEnabled)
exec("terr\\terrgrnt.cs");

if($TerrPakPref::MasterAutoUse)
exec("terr\\terrause.cs");

if($TerrPakPref::MiscOptions)
exec("terr\\terrmisc.cs");

